GZIP(1)

NAME
gzip, gunzip, gzcat - compress and expand data (deflate mode)

SYNOPSIS
gzip [-123456789cdfhLlNnOqrtVv] [-b bits] [-o filename] [-S suffix] [file ...]
gunzip [-cfhLlNnqrtVv] [-o filename] [file ...]
gzcat [-fhqr] [file ...]

DESCRIPTION
The gzip utility reduces the size of the named files using adaptive Lempel-Ziv coding, in deflate mode. If invoked as gzip -O, the compress mode of compression is chosen; see compress(1) for more information. Each file is renamed to the same name plus the extension “.gz”. As many of the modification time, access time, file flags, file mode, user ID, and group ID as allowed by permissions are retained in the new file. If compression would not reduce the size of a file, the file is ignored (unless -f is used).

The gunzip utility restores compressed files to their original form, renaming the files by removing the extension (or by using the stored name if the -N flag is specified). It has the ability to restore files compressed by both gzip and compress(1), recognising the following extensions: “.Z”, “-Z”, “_Z”, “.gz”, “-gz”, “_gz”, “.tgz”, “-tgz”, “_tgz”, “.taz”, “-taz”, and “_taz”. Extensions ending in “tgz” and “taz” are not removed when decompressing, instead they are converted to “tar”.

The gzcat command is equivalent in functionality to gunzip -c.

If renaming the files would cause files to be overwritten and the standard input device is a terminal, the user is prompted (on the standard error output) for confirmation. If prompting is not possible or confirmation is not received, the files are not overwritten.

If no files are specified, the standard input is compressed or uncompressed to the standard output. If either the input or output files are not regular files, the checks for reduction in size and file overwriting are not performed, the input file is not removed, and the attributes of the input file are not retained.

By default, when compressing, the original file name and time stamp are stored in the compressed file. When uncompressing, this information is not used. Instead, the uncompressed file inherits the time stamp of the compressed version and the uncompressed file name is generated from the name of the compressed file as described above. These defaults may be overridden by the -N and -n flags, described below.

The options are as follows:

-1...9
    Use the deflate scheme, with compression factor of -1 to -9. Compression factor -1 is the fastest, but provides a poorer level of compression. Compression factor -9 provides the best level of compression, but is relatively slow. The default is -6.

-b bits
    Specify the bits code limit (see below).

-c  Compressed or uncompressed output is written to the standard output. No files are modified (force gzcat mode).

-d  Decompress the source files instead of compressing them (force gunzip mode).

-f  Force compression of file, even if it is not actually reduced in size. Additionally, files are overwritten without prompting for confirmation. If the input data is not in a format recognized by gzip and if the option -c is also given, copy the input data without change to the standard output: let gzcat behave as cat(1).

-h  Print a short help message.

-L  A no-op which exists for compatibility only. On GNU gzip, it displays the program's license.

-l  List information for the specified compressed files. The following information is listed:

    compressed size
        Size of the compressed file.

    uncompressed size
        Size of the file when uncompressed.

    compression ratio
        Ratio of the difference between the compressed and uncompressed sizes to the uncompressed size.

    uncompressed name
        Name the file will be saved as when uncompressing.

    If the -v option is specified, the following additional information is printed:

    compression method
        Name of the method used to compress the file.

    crc 32-bit CRC (cyclic redundancy code) of the uncompressed file.

    time stamp
        Date and time corresponding to the last data modification time (mtime) of the compressed file (if the -n option is specified, the time stamp stored in the compressed file is printed instead).

-N  When uncompressing or listing, use the time stamp and file name stored in the compressed file, if any, for the uncompressed version.

-n  When compressing, do not store the original file name and time stamp in the gzip header.

-O  Use old compression method (force compress(1) mode).

-o filename
    Set the output file name.

-q  Be quiet: suppress all messages.

-r  Recursive mode: gzip will descend into specified directories.

-S suffix
    Set the suffix for compressed files.

-t  Test the integrity of each file leaving any files intact.

-V  A no-op which exists for compatibility only. On GNU gzip, it displays version information.

-v  Print the percentage reduction of each file and other information.

gzip uses a modified Lempel-Ziv algorithm (LZW). Common substrings are replaced by pointers to previous strings, and are found using a hash table. Unique substrings are emitted as a string of literal bytes, and compressed as Huffman trees. When code 512 is reached, the algorithm switches to 10-bit codes and continues to use more bits until the limit specified by the -b flag is reached. bits must be between 9 and 16 (the default is 16).

After the bits limit is reached, gzip periodically checks the compression ratio. If it is increasing, gzip continues to use the existing code dictionary. However, if the compression ratio decreases, gzip discards the table of substrings and rebuilds it from scratch. This allows the algorithm to adapt to the next “block” of the file.

The -b flag is omitted for gunzip since the bits parameter specified during compression is encoded within the output, along with a magic number to ensure that neither decompression of random data nor recompression of compressed data is attempted.

The amount of compression obtained depends on the size of the input, the number of bits per code, and the distribution of common substrings. Typically, text such as source code or English is reduced by 60 - 70% using gzip. Compression is generally much better than that achieved by Huffman coding (as used in the historical command pack), or adaptive Huffman coding (as used in the historical command compact), and takes less time to compute.

ENVIRONMENT

GZIP
    Options which are passed to gzip, gunzip, and gzcat automatically.

EXIT STATUS
The gzip utility exits with one of the following values:

0   Success.
1   An error occurred.
2   At least one of the specified files was not compressed since -f was not specified and compression would have resulted in a size increase.
2   An error occurred.

The gunzip and gzcat utilities exit 0 on success, and >0 if an error occurs.

SEE ALSO
compress(1), gzexe(1), zdiff(1), zforce(1), zmore(1), znew(1), compress(3)

STANDARDS
P. Deutsch, J-L. Gailly, May 1996, RFC 1950, ZLIB Compressed Data Format Specification version 3.3.

P. Deutsch, May 1996, RFC 1951, DEFLATE Compressed Data Format Specification version 1.3.

P. Deutsch, May 1996, RFC 1952, GZIP file format specification version 4.3.

HISTORY
gzip compatibility was added to compress(1) in OpenBSD 3.4. The ‘g’ in this version of gzip stands for “gratis”.